function parseColor(color)
{
    var r, g, b;

    r = parseInt(color.substr(1, 2), 16);
    g = parseInt(color.substr(3, 2), 16);
    b = parseInt(color.substr(5, 2), 16);

    return {r: r, g: g, b: b};
}

function formatColor(rgb)
{
    return '#' + prependZeros(2, rgb['r'].toString(16)) + prependZeros(2, rgb['g'].toString(16)) + prependZeros(2, rgb['b'].toString(16));
}

function prependZeros(amount, str) {
    str = str.toString();
    while (str.length < amount) {
        str = '0' + str;
    }
    return str;
}

function lerpColor(start, end, percent)
{
    var s, e, n;

    s = parseColor(start);
    e = parseColor(end);

    n = {};
    n.r = Math.floor(Crafty.math.lerp(s.r, e.r, percent));
    n.g = Math.floor(Crafty.math.lerp(s.g, e.g, percent));
    n.b = Math.floor(Crafty.math.lerp(s.b, e.b, percent));

    return formatColor(n);
}