Crafty.scene("game", function()
{
    // Backgrounds
    Crafty.background("#000000");
    Crafty.e("2D, Canvas, Image").image("img/starsbg.png").attr({x: 0, y: 0});

    Crafty.e("Canvas, Laser");

    // Top planet
    Crafty.e("2D, Canvas, Image").image("img/mars.png").attr({x: 0, y: 0});

    // Bottom planet. When the swarm reaches the planet, the game is over.
    Crafty.e("2D, Canvas, Image, Collision")
        .image("img/earth.png")
        .attr({x: 0, y: Crafty.viewport.height - 17})
        .onHit('ship1', function() {
            Crafty.trigger('GameOver');
            swarmGame.doGameOver();
            Crafty("Jelly").trigger("Freeze");
        });

    // Top right score
    Crafty.e('Score');

    // When the user clicks in the game window, fire the laser.
    Crafty.e("mouseTracking, 2D, Mouse, Touch, Canvas")
        .attr({ w:Crafty.viewport.width, h:Crafty.viewport.height, x:0, y:0 })
        .bind('MouseDown', function(e) {
            if (swarmGame.gameState.gameOver === false) {
                Crafty.trigger('Fire', {x: Crafty.mousePos.x, y: Crafty.mousePos.y});
                Crafty.audio.play('laser' + Crafty.math.randomInt(1,2));
                swarmGame.gameState.stats.shots++;
            }
        });

    Crafty.audio.play('start');

    // Enemy spawner
    var spawner = Crafty.e('Spawner');
    spawner.trigger('Start');
});