/***
 *
 * A jelly has different behavior at different levels.
 *
 * Level 1: ?pps, straight down
 * Level 2: ?pps, straight down
 * Level 3: ?pps, moves left and right in 100 pixel slides
 *
 * TODO: Need some alternate graphics for higher level Jelly's.
 *
 */
Crafty.c("Jelly", {
    setLevel: function(level) {
        this._level = level;

        switch (this._level) {
            case 1:
                this._yspeed = 80;
                this._xspeed = 0;
                this._xslide = 0;
                break;
            case 2:
                this._yspeed = 100;
                this._xspeed = 0;
                this._xslide = 0;
                break;
            case 3:
                this._yspeed = 120;
                this._xspeed = 50;
                this._xslide = 100;
                break;
            case 4:
                this._yspeed = 130;
                this._xspeed = 50;
                this._xslide = 100;
        }
    },
    init: function() {

        var gs = swarmGame.gameState;
        this.setLevel(1);

        this.addComponent("2D, Canvas, ship1, animate, Mouse, Delay");
        this.origin("center");

        this.attr({
            x: Crafty.math.randomInt(50, swarmGame.spawnWidth - 50),
            y: Crafty.math.randomInt(35, 3),
            w: 32, // width
            h: 32  // height
        });

        this.xorig = this.x;
        this.xdir = Crafty.math.randomElementOfArray([-1, 1]);

        this.bind("EnterFrame", function(frame) {
            if (gs.gameOver == true)
                return;

            if (Crafty.math.abs(this.xorig - this.x) > this._xslide) {
                this.xdir *= -1;
            }

            this.x += (this._xspeed * (frame.dt/1000) * this.xdir);
            this.y += this._yspeed * (frame.dt/1000);

        });

        // Show a smiley face
        this.bind('GameOver', function() {
            this.removeComponent('ship1').addComponent('ship4');
        });

        // Ship is hit with the laser
        this.bind('Click', function(e) {
            var gs = swarmGame.gameState;

            if (gs.gameOver == true)
                return;

            Crafty.trigger('Fire', {x: Crafty.mousePos.x, y: Crafty.mousePos.y});
            gs.stats.shots++;

            if (this.has("ship1")) {
                this.removeComponent("ship1").addComponent("ship2");
                Crafty.trigger('ScoreUpdate', 100 * gs.level);
                Crafty.audio.play('laser' + Crafty.math.randomInt(1,2));
                Crafty.audio.play('explosion');

                gs.stats.kills++;
                if (gs.stats.kills % 10 == 0)
                    gs.level++;

                this.delay(function() {
                    this.destroy();
                }, 200);
            }
        });
    }
});