var swarmGame = {
    viewportWidth: 960,
    viewportHeight: 540,
    spawnWidth: 960 - 50,
    spawnHeight: 540 - 50,
    gameState: {
        level: 1,
        gameOver: true,
        stats: {
            kills: 0,
            shots: 0,
            time: 0,
            wins: 0
        }
    },
    init: function() {
        Crafty.init(this.viewportWidth, this.viewportHeight, "game");
        Crafty.canvas.init();
    },
    resetState: function() {
        var gs = this.gameState;
        gs.level = 1;
        gs.stats.kills = 0;
        gs.stats.shots = 0;
        gs.stats.time = 0;
        gs.stats.wins = 0;
        gs.gameOver = false;

    },
    resetGame: function() {
        swarmGame.resetState();
        Crafty("Jelly").destroy();
        Crafty.scene("game");
    },
    doGameOver: function() {
        var gs = swarmGame.gameState;
        var accuracy = 0;

        gs.gameOver = true;
        Crafty('Jelly').trigger('GameOver');

        Crafty.e("GameOverBg, 2D, DOM, Image, Mouse")
            .image("img/gameover.png")
            .attr({x: 250, y: 150})
            .bind("Click", function() {
                this.destroy();
                swarmGame.resetGame();
            });

        Crafty.e("Stats1, 2D, DOM, Text, Color")
            .attr({ x: 440, y: 280, w: 200, h: 30 })
            .textFont({size: '16px', family: 'Arial', weight: 'bold'})
            .textColor('blue', 16)
            .text("Kills: " + gs.stats.kills);

        Crafty.e("Stats1, 2D, DOM, Text, Color")
            .attr({ x: 440, y: 300, w: 200, h: 30 })
            .textFont({size: '16px', family: 'Arial', weight: 'bold'})
            .textColor('blue', 16)
            .text("Shots Fired: " + gs.stats.shots);

        if (gs.stats.shots > 0)
            accuracy = Math.round((gs.stats.kills/gs.stats.shots) * 100);

        Crafty.e("Stats1, 2D, DOM, Text, Color")
            .attr({ x: 440, y: 320, w: 200, h: 30 })
            .textFont({size: '16px', family: 'Arial', weight: 'bold'})
            .textColor('blue', 16)
            .text("Accuracy: " + accuracy + ' %');
    }
}

swarmGame.init();


// Asset loader

Crafty.load(
    [
        "img/earth.png",
        "img/mars.png",
        "img/starsbg.png",
        "img/gameover.png",
        "snd/explosion.wav",
        "snd/start.wav",
        "snd/laser1.wav",
        "snd/laser2.wav"
    ],
    // On Load complete
    function() {

        Crafty.audio.add({
            start: [
                "snd/start.wav"
            ],
            laser1: [
                "snd/laser1.wav"
            ],
            laser2: [
                "snd/laser2.wav"
            ],
            explosion: [
                "snd/explosion.wav"
            ]
        });

        Crafty.sprite(32, "img/ship1.png", {
            ship1: [0, 0],
            ship2: [1, 0],
            ship3: [2, 0],
            ship4: [3, 0]
        });



        // Start the game
        swarmGame.resetGame();
    },

    // Load in progress
    function(e) {
    },
    // Load error
    function(e) {
    }
);


/*

if (window.innerWidth < 960) {
    viewportWidth = Crafty.DOM.window.width;
    viewportHeight = Crafty.DOM.window.height;
} else {
    viewportWidth = 960;
    viewportHeight = 540;
//}

*/