Crafty.c("Spawner", {
    // ["Entity", level, quantity, spawn delay, spawn start offset]
    waves: [
        [
            ["Jelly", 1, 5, 1000, 0],
            ["Jelly", 2, 5, 1000, 5000],

        ],
        [
            ["Jelly", 1, 10, 1000, 0],
            ["Jelly", 2, 5, 1000, 5000]
        ],
        [
            ["Jelly", 1, 5, 800, 0],
            ["Jelly", 1, 5, 800, 0]
        ],
        [
            ["Jelly", 1, 5, 500, 0],
            ["Jelly", 2, 7, 700, 0]
        ],
        [
            ["Jelly", 1, 5, 3000, 0],
            ["Jelly", 2, 10, 1500, 0],
            ["Jelly", 3, 10, 1000, 0]
        ],
    ],

    schedule: function(level) {
        var levelTime = 0;

        if (!this.spawning)
            return;

        if (level >= this.waves.length)
            level = this.waves.length - 1;

        this.levelItems = 0;

        for (var wave = 0; wave < this.waves[level].length; wave++) {
            var item = this.waves[level][wave];
            this.levelItems += item[2];
            if (item[2] * item[3] + item[4] > levelTime)
                levelTime = item[2] * item[3] + item[4];
            this.postpone()(this, item);

        }
    },
    postpone: function() {
        return function(instance, item) {
            instance.sleep(function() {
                console.log("Awaking from sleep to spawn");
                instance.delay(function() {
                    if (this.spawning) {
                        var e = Crafty.e(item[0]);
                        e.setLevel(item[1]);
                    }
                }, item[3], item[2]);
            }, item[4]);
        }
    },
    init: function() {
        this.addComponent("Delay");
        this.level = 0;
        this.spawning = true;

        this.bind('Start', function() {
            this.levelItems = 0;
            this.schedule(this.level);
        });

        this.bind('Stop', function() {
            this.spawning = false;
            console.log('Stop');
        });

        this.bind('GameOver', function() {
            this.spawning = false;
        });

        this.bind('Fire', function() {
            this.levelItems--;
            if (0 === this.levelItems) {
                console.log("End of Level: " + this.level);
                this.sleep(function() {
                    this.level++;
                    if (this.spawning)
                        this.schedule(this.level);
                }, 5000);
            }
        });
    },

    sleep: function(callback, interval) {
        this.delay(function() {
            callback.call(this);
        }, interval);
    }
});